#!/usr/bin/perl -w
###################################
# Collect decoys from refinement  #
###################################
$ss=$ARGV[0];
$recorddir=$ARGV[1];
$outdir=$ARGV[2];
$usr=$ARGV[3];
################# directories #########################
$work_dir="/tmp/$usr/collec$ss";
`mkdir -p $work_dir`;
chdir "$work_dir" or die "Cannot chdirto $work_dir, quit!\n";
`rm -f $work_dir/*`;

################# copy files ##########################
`cp -f $recorddir/$ss.tar.bz2 .`;

`tar jxvf $ss.tar.bz2`;
`rm $ss.tar.bz2`;

############## collect refined decoys #################
%dref=();
@lists=<$recorddir/REF*>;
foreach $lst (@lists){
  open(LST, "$lst") or die "Cannot open $lst. $!\n";
  while($line=<LST>){
    if($line=~/(\S+)\s+\S+\s+\S+/){
      $dref{$1}=$line;
      chomp($dref{$1});
    }
  }
  close(LST);
  `rm $lst`;
}

open(OUT,"> refined.txt") or die "Can't make: refined.txt $!\n";
$dlist=`cat $ss/list.txt`;
@dcys= keys %dref;
foreach $dcy (@dcys){
  if(-s "$outdir/$dcy"){
    $sub=substr($dref{$dcy},0,26);
    $dlist=~s/$dcy\s+\S+/$sub/mg;
    printf OUT "$dref{$dcy}\n";
  }else{
    print "Warning: Cannot find $outdir/$dcy. Skip!\n";
    `/bin/cp -f $ss/$dcy $outdir/`;
  }
}
close(OUT);
`rm refined.txt` if -s "refined.txt" <20;

open(NLST,"> $outdir/list.txt") or die "Can't make: $outdir/list.txt $!\n";
print NLST $dlist;
close(NLST);


################# copy files back ##########################
`/bin/cp -f refined.txt $recorddir/`;

################# endding procedure ######################
`sync`;
sleep(1);
`rm -fr $work_dir`;
exit();